import { hydrate as domLegacyHydrate, render as domLegacyRender, unmountComponentAtNode } from "react-dom";
import { createRoot as domCreateRoot, hydrateRoot as domHydrateRoot } from "react-dom/client";
function hydrate(element, root) {
  return domHydrateRoot(root, element);
}
function render(element, root) {
  const reactRoot = domCreateRoot(root);
  return reactRoot.render(element), reactRoot;
}
function hydrateLegacy(element, root, callback) {
  return domLegacyHydrate(element, root, callback), {
    unmount: function () {
      return unmountComponentAtNode(root);
    }
  };
}
function renderLegacy(element, root, callback) {
  return domLegacyRender(element, root, callback), {
    unmount: function () {
      return unmountComponentAtNode(root);
    }
  };
}
export { renderLegacy as default, hydrate, hydrateLegacy, render };
//# sourceMappingURL=index.mjs.map
